const state = {
  searchParams: {
    // [route.path]: { ...searchContent }
  }
}

const mutations = {
  SET_SEARCH_PARAMS: (state, config) => {
    if (!config || typeof config !== 'object') { return }
    if (!config.path) { return }
    if (config.param && typeof config.param === 'object' && Object.keys(config.param).length > 0) {
      state.searchParams[config.path] = JSON.stringify(config.param)
    } else {
      delete state.searchParams[config.path]
    }
  },
  RSET_SEARCH_PARAMS: (state) => {
    state.searchParams = {}
  },
  CLEAR_ONE_PARAMS: (state, path) => {
    path && state.searchParams[path] && delete state.searchParams[path]
  }
}

const actions = {
  searchParamsSet({ commit }, config) {
    if (!config || typeof config !== 'object') { return }
    if (!config.path) { return }
    commit('SET_SEARCH_PARAMS', config)
  },
  restSearchParams({ commit }) {
    commit('RSET_SEARCH_PARAMS')
  },
  clearOneParams({ commit }, path) {
    commit('CLEAR_ONE_PARAMS', path)
  }
}

export default {
  namespaced: true,
  state,
  mutations,
  actions
}
